package de.lmu.ifi.pst.uwejsf.framework;

import java.util.Map;

import javax.script.ScriptContext;
import javax.script.ScriptEngine;

public class OGNLMethodHandler implements MethodHandler {

	private String expression;

	@Override
	public Object execute(Object obj, Map<String, Object> parameters) {
		if (expression == null)
			return null;
		AbstractUWEContextFactory contextFactory = AbstractUWEContextFactory
				.getCurrentInstance();
		ScriptEngine engine = contextFactory.getScriptEngineByName("ognl");
		ScriptContext scriptContext = contextFactory.createScriptContext(obj);
		scriptContext.getBindings(ScriptContext.ENGINE_SCOPE)
				.putAll(parameters);
		Object result = null;
		try {
			result = engine.eval(expression, scriptContext);
		} catch (Exception e) {
			throw new NavigationException("Couldn't evaluate OGNL script: "
					+ expression, e);
		}
		return result;

	}

	@Override
	public String getExpression() {
		return expression;
	}

	@Override
	public void setExpression(String expression) {
		this.expression = expression;

	}

}
